# Do not modify this file!  It was generated by ‘nixos-generate-config’
# and may be overwritten by future invocations.  Please make changes
# to /etc/nixos/configuration.nix instead.
{
  config,
  lib,
  pkgs,
  modulesPath,
  ...
}:

{
  disabledModules = [ "system/boot/luksroot.nix" ];

  imports = [
    (modulesPath + "/installer/scan/not-detected.nix")
    ./my-luksroot.nix
  ];

  boot.initrd = {
    kernelModules = [
      "vfat"
      "nls_cp437"
      "nls_iso8859-1"
      "usbhid"
    ];

    luks = {
      yubikeySupport = true;
      reusePassphrases = true;
      devices."crypted_root" = {
        device = "/dev/disk/by-partlabel/disk-main-luks";

        yubikey = {
          slot = 2;
          twoFactor = true;
          gracePeriod = 30;
          keyLength = 64;
          saltLength = 16;
          replaceKey = false;

          storage = {
            device = "/dev/disk/by-partlabel/disk-main-ESP";
            fsType = "vfat";
            path = "/crypt-storage/default";
          };
        };
      };
      devices."crypted_backup" = {
        device = "/dev/disk/by-partlabel/disk-backup-luks";

        yubikey = {
          slot = 2;
          twoFactor = true;
          gracePeriod = 30;
          keyLength = 64;
          saltLength = 16;
          replaceKey = false;

          storage = {
            device = "/dev/disk/by-partlabel/disk-backup-ESP";
            fsType = "vfat";
            path = "/crypt-storage/default";
          };
        };
      };
    };
  };
  boot.kernelModules = [ "kvm-amd" ];
  boot.extraModulePackages = [ ];

  # Enables DHCP on each ethernet and wireless interface. In case of scripted networking
  # (the default) this is the recommended approach. When using systemd-networkd it's
  # still possible to use this option, but it's recommended to use it in conjunction
  # with explicit per-interface declarations with `networking.interfaces.<interface>.useDHCP`.
  networking.useDHCP = lib.mkDefault true;
  # networking.interfaces.enp196s0f3u1u4.useDHCP = lib.mkDefault true;
  # networking.interfaces.wlp2s0.useDHCP = lib.mkDefault true;

  nixpkgs.hostPlatform = lib.mkDefault "x86_64-linux";
  hardware.cpu.amd.updateMicrocode = lib.mkDefault config.hardware.enableRedistributableFirmware;
}
